package cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.excel.ExportUtils;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;
import cn.com.qmth.dp.examcloud.oe.util.FileUtil;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

@Service
public class ExportReduplicateQuestionService {

    /*
     * *****!!!!!!!!!!!!!!!!!***********需要修改 试卷排除 名称
     ************* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     ********/

    private Long rootOrgId = 18735L;
    // private Long rootOrgId = 17351L;

    private String mode = "file";

    private String dir = "e:/files/dianke/241205/";
    // private String dir = "e:/files/yunkai/241204/";

    // private String paperName = "230517";
    private int threadCount = 8;

    public void start() {
        Date s = new Date();
        ExportQuesReduplicateProducer pr = SpringContextHolder.getBean(ExportQuesReduplicateProducer.class);
        File file;
        try {
            Map<String, Object> param = new HashMap<>();
            param.put("rootOrgId", rootOrgId);
            param.put("mode", mode);
            param.put("dir", dir);
            // param.put("paperName", paperName);
            pr.startDispose(ExportQuesReduplicateConsumer.class, threadCount, param);
            List<RetDto> ret = new ArrayList<>();
            for (Consumer c : pr.getConsumers()) {
                ret.addAll(c.getRet());
            }
            FileOutputStream fos = null;
            try {
                file = FileUtil.createFile(dir, "duplicatequestion.xlsx");
                fos = new FileOutputStream(file);
                ExportUtils.makeExcel(RetDto.class, ret, fos);
            } catch (Exception e) {
                throw new RuntimeException(e);
            } finally {
                if (fos != null) {
                    try {
                        fos.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        } catch (Exception e) {
            throw new RuntimeException(e);

        }
        Date e = new Date();
        System.out.println("finish | time:" + (e.getTime() - s.getTime()));
        System.out.println("finish | filePath:  " + file.getAbsolutePath());
    }

}
